﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Controls.Primitives;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.GridView;
using Telerik.Windows.Data;

namespace _824226_RadGridView_SL5_AR_13
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();

            this.clubsGrid.LayoutUpdated += clubsGrid_LayoutUpdated;
        }

        void clubsGrid_LayoutUpdated(object sender, EventArgs e)
        {
            ScrollBar horizontalScrollBar = this.clubsGrid.ChildrenOfType<ScrollBar>().Where(b => b.Name == "PART_HorizontalScrollBar").FirstOrDefault();

            if (horizontalScrollBar != null)
            {
                horizontalScrollBar.ValueChanged -= horizontalScrollBar_ValueChanged;
                horizontalScrollBar.ValueChanged += horizontalScrollBar_ValueChanged;
            }

            this.clubsGrid.LayoutUpdated -= clubsGrid_LayoutUpdated;
        }

        private void horizontalScrollBar_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            var childGridViews = this.clubsGrid.ChildrenOfType<RadGridView>();

            foreach (var gridView in childGridViews)
            {
                var scrollViewer = gridView.ChildrenOfType<GridViewScrollViewer>().FirstOrDefault();

                if (scrollViewer != null)
                {
                    scrollViewer.ScrollToHorizontalOffset(e.NewValue);
                }
            }
        }


        private void playersGrid_Loaded(object sender, RoutedEventArgs e)
        {
            ScrollBar horizontalScrollBar2 = (sender as RadGridView).ChildrenOfType<ScrollBar>().Where(b => b.Name == "PART_HorizontalScrollBar").FirstOrDefault();

            if (horizontalScrollBar2 != null)
            {
                horizontalScrollBar2.ValueChanged -= horizontalScrollBar2_ValueChanged;
                horizontalScrollBar2.ValueChanged += horizontalScrollBar2_ValueChanged;
            }

            (sender as RadGridView).Loaded -= playersGrid_Loaded;
        }

        private void horizontalScrollBar2_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            var parentGridView = (sender as ScrollBar).ParentOfType<RadGridView>().ParentOfType<RadGridView>();
            var scrollViewer = parentGridView.ChildrenOfType<GridViewScrollViewer>().FirstOrDefault();

            if (scrollViewer != null)
            {
                scrollViewer.ScrollToHorizontalOffset(e.NewValue);
            }
        }
    }
}